import { jsx } from "react/jsx-runtime";
import { useCallback } from "react";
import { TableOutlined } from "@ant-design/icons";
import { SchemaInitializerItem, useSchemaInitializer, useSchemaInitializerItem } from "../../application/index.mjs";
import { useCollectionManager_deprecated } from "../../collection-manager/index.mjs";
import { createGridCardBlockUISchema } from "../../modules/blocks/data-blocks/grid-card/createGridCardBlockUISchema.mjs";
import { useSchemaTemplateManager } from "../../schema-templates/index.mjs";
import { useRecordCollectionDataSourceItems } from "../utils.mjs";
const RecordAssociationGridCardBlockInitializer = ()=>{
    const itemConfig = useSchemaInitializerItem();
    const { onCreateBlockSchema, componentType, createBlockSchema, ...others } = itemConfig;
    const { insert } = useSchemaInitializer();
    const { getTemplateSchemaByMode } = useSchemaTemplateManager();
    const { getCollection } = useCollectionManager_deprecated();
    const field = itemConfig.field;
    const collection = getCollection(field.target);
    const resource = "".concat(field.collectionName, ".").concat(field.name);
    return /*#__PURE__*/ jsx(SchemaInitializerItem, {
        icon: /*#__PURE__*/ jsx(TableOutlined, {}),
        ...others,
        onClick: async (param)=>{
            let { item } = param;
            if (item.template) {
                const s = await getTemplateSchemaByMode(item);
                insert(s);
            } else insert(createGridCardBlockUISchema({
                rowKey: collection.filterTargetKey,
                dataSource: collection.dataSource,
                association: resource
            }));
        },
        items: useRecordCollectionDataSourceItems('GridCard', itemConfig, field.target, resource)
    });
};
function useCreateAssociationGridCardBlock() {
    const { insert } = useSchemaInitializer();
    const { getCollection } = useCollectionManager_deprecated();
    const createAssociationGridCardBlock = useCallback((param)=>{
        let { item } = param;
        const field = item.associationField;
        const collection = getCollection(field.target);
        insert(createGridCardBlockUISchema({
            rowKey: collection.filterTargetKey,
            dataSource: collection.dataSource,
            association: "".concat(field.collectionName, ".").concat(field.name)
        }));
    }, [
        getCollection,
        insert
    ]);
    return {
        createAssociationGridCardBlock
    };
}
export { RecordAssociationGridCardBlockInitializer, useCreateAssociationGridCardBlock };
